package rdt;

import java.util.*;

/**
 *  The Logger class provides logging for the reliable data transfer
 *  simulation.
 */
public class Logger {

    /**
     *  startTime is the time that the Logger was started.
     */ 
    private static long startTime;

    /**
     *  Logger.start() initializes Logger.
     */ 
    public static void start() {
        System.out.println("Simulation log:");
        System.out.println("---------------");
        startTime = System.currentTimeMillis();
    }  // public static void start()

    /**
     *  Logger.log(typ) logs a message of type typ.
     */ 
    public static synchronized void log(String typ) {
        long time = System.currentTimeMillis() - startTime;
        System.out.print(Long.toString(time));
        System.out.println(" - " + typ + ".");
    }  // public static synchronized void log(String)

    /**
     *  Logger.log(typ, pkt) logs a message of type typ about Packet pkt.
     */ 
    public static synchronized void log(String typ, Packet pkt) {
        long time = System.currentTimeMillis() - startTime;
        System.out.print(Long.toString(time));
        System.out.print(" - " + typ);
        System.out.println(": " + pkt + ".");
    }  // public static synchronized void log(String, Packet)

    /**
     *  Logger.println() adds a blank line to the log.
     */ 
    public static synchronized void println() {
        System.out.println();
    }  // public static synchronized void println()

}  // public class Logger

